unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Spin, Math;

type
  TForm1 = class(TForm)
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  SpinEdit2.MinValue := SpinEdit1.Value;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  SpinEdit1.MaxValue := SpinEdit2.Value;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i:integer;
begin
  StringGrid1.Cells[0,0] := 'X fok';
  StringGrid1.Cells[1,0] := 'sin(X)';
  StringGrid1.RowCount := SpinEdit2.Value-SpinEdit1.Value+2;
  for i:=SpinEdit1.Value to SpinEdit2.Value do
    begin
    StringGrid1.Cells[0,i-SpinEdit1.Value+1] := IntToStr(i);
    StringGrid1.Cells[1,i-SpinEdit1.Value+1] :=
                     FloatToStr(RoundTo(sin(PI/180*i),-10));
    end;
end;

end.
