unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit2;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  { TKonyv tipus definialasa }
  TKonyv = record
             Szerzo, Cim: string[255];
             Oldalak, Ar: integer;
           end;

var
  { tomb, file deklaralasa }
  a: array[1..10000] of TKonyv;
  f: file of TKonyv;
  { n - konyvek szama a tombben }
  n: integer;
  { akt - aktualis, megjelenitett konyv }
  akt: integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
 n:=0;
 { adatok beolvasasa kulso fajlbol }
 AssignFile(f,'konyvek.dat');
 try
   Reset(f);
   try
     while not eof(f) do
       begin
         inc(n);
         Read(f,a[n]);
       end;
   finally
     CloseFile(f);
   end;
 except
   MessageDlg('Hiba az adatok megnyitasakor.'
               + chr(10) + chr(13) + 'A file nem letezik?',
               mtWarning,[mbOK],0);
 end;
 { elso konyv megjelenitese, ha letezik }
 if n>0 then begin
              akt := 1;
              Label5.Caption := a[1].Szerzo;
              Label6.Caption := a[1].Cim;
              Label7.Caption := IntToStr(a[1].Oldalak);
              Label8.Caption := IntToStr(a[1].Ar);
             end
        else begin
              akt := 0;
              Label5.Caption := '';
              Label6.Caption := '';
              Label7.Caption := '';
              Label8.Caption := '';
             end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  { ugras az elozore }
  if akt>1 then
    begin
     dec(akt);
     Label5.Caption := a[akt].Szerzo;
     Label6.Caption := a[akt].Cim;
     Label7.Caption := IntToStr(a[akt].Oldalak);
     Label8.Caption := IntToStr(a[akt].Ar);
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  { ugras a kovetkezore }
  if akt<n then
    begin
     inc(akt);
     Label5.Caption := a[akt].Szerzo;
     Label6.Caption := a[akt].Cim;
     Label7.Caption := IntToStr(a[akt].Oldalak);
     Label8.Caption := IntToStr(a[akt].Ar);
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i: integer;
begin
  { uj konyv hozzaadasa Form2 megjelenitesevel }
  if Form2.ShowModal = mrOk then
    begin
    { a konyv helyenek megkeresese ugy, hogy
      a konyvek cimei ABC szerint legyenek rendezve }
    i := n;
    while (i>0) and (a[i].Cim>Form2.Edit2.Text) do
      begin
       a[i+1] := a[i];
       dec(i);
      end;
    a[i+1].Szerzo := Form2.Edit1.Text;
    a[i+1].Cim := Form2.Edit2.Text;
    a[i+1].Oldalak := StrToInt(Form2.Edit3.Text);
    a[i+1].Ar := StrToInt(Form2.Edit4.Text);
    inc(n);
    { a beirt konyv begjelenitese }
    akt := i;
    Button2.Click;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: integer;
begin
 { adatok mentese fajlba }
 try
   Rewrite(f);
   try
     for i:=1 to n do Write(f,a[i]);
   finally
     CloseFile(f);
   end;
 except
   MessageDlg('Hiba az adatok mentsnl!',
               mtError,[mbOK],0);
 end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  i: integer;
begin
  { a torolt konyv utani konyvek
    eggyel elobbre helyezese }
  for i := akt to n-1 do a[i] := a[i+1];
  dec(n);
  { kovetkezo, vagy elozo konyv
    megjelenitese, ha van ilyen }
  if akt<=n then begin
                 dec(akt);
                 Button2.Click;
                 end
            else if n>0 then begin
                             akt := n-1;
                             Button2.Click;
                             end
                        else begin
                             akt := 0;
                             Label5.Caption := '';
                             Label6.Caption := '';
                             Label7.Caption := '';
                             Label8.Caption := '';
                             end;
end;

end.
